require "defines"




--Config options
check_interval = 5 --in seconds
notification_interval = 5 --Will message every 5 rockets
--End of config options








script.on_configuration_changed(function(data)
   if data.mod_changes ~= nil and data.mod_changes["Auto_Launch"] ~= nil and data.mod_changes["Auto_Launch"].old_version == nil then
   	local s = game.surfaces["nauvis"]
   	init(s)
   end
 end)


function init(s)
	if global.silos == nil then
		global.silos = {}
	for c in s.get_chunks() do
  for k, silos in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name="rocket-silo"})) do

      table.insert(global.silos, silos)
  end
end
--game.players[1].print("Added existing silos to Autolaunch list")
end
end

function CheckSilos()
	if game.tick % (check_interval * 60) == 0 then --Check every 5 seconds
	if global.silos ~= nil then
	for k, silos in pairs (global.silos) do
		if silos.valid then
			if silos.get_item_count("satellite") > 0 then --game.players[1].print("Silo has satellite")
				silos.launch_rocket()
        if global.satellite_sent == nil then
          global.satellite_sent = {}
        end
				local force = silos.force
					for k, player in pairs (game.players) do
						if player.force == force then
              if global.satellite_sent[force.name] == nil then
                player.print("First rocket has been launched")
              else
                if global.satellite_sent[force.name] % notification_interval == 0 then
                player.print(notification_interval.." rockets have been sent")
                end
              end
							--player.print("Rocket launch in progress")
						end
					end
			end
		else table.remove(global.silos, k) --game.players[1].print("Silo Removed from index")
		end
	end
end
end
end

function BuiltEntity(event)
	if global.silos ==nil then global.silos = {} end

	if event.created_entity.name == "rocket-silo" then
		local silos = event.created_entity
			table.insert(global.silos, silos)
	end
end

script.on_event(defines.events.on_tick, CheckSilos)
script.on_event(defines.events.on_built_entity, BuiltEntity)
script.on_event(defines.events.on_robot_built_entity, BuiltEntity)

